# Data (ARX Developer Documentation)

org.deidentifier.arx.framework.data

## Class Data

- java.lang.Object
- - org.deidentifier.arx.framework.data.Data

- All Implemented Interfaces:
    java.lang.Cloneable

      public class Data
      extends java.lang.Object
      implements java.lang.Cloneable

  Encodes a data object consisting of a dictionary encoded two-dimensional array, an associated dictionary, a header and a mapping to the columns in the input data set.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `OUTLIER_MASK` The outliers mask.
    `static int` | `REMOVE_OUTLIER_MASK` The inverse outliers mask.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Data(int[][] data, java.lang.String[] header, int[] map, Dictionary dictionary)` Creates a new data object.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Data` | `clone()`
    `int[][]` | `getArray()` Returns the data array.
    `int[][]` | `getData()` Returns the data.
    `int` | `getDataLength()` Returns the number of rows.
    `Dictionary` | `getDictionary()` Returns the dictionary.
    `java.lang.String[]` | `getHeader()` Returns the header.
    `int[]` | `getMap()` Returns the map.
    `Data` | `getSubsetInstance(RowSet rowset)` Returns a new instance that is projected onto the given subset

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### OUTLIER_MASK

          public static final int OUTLIER_MASK

      The outliers mask.
      See Also:
        Constant Field Values

    - #### REMOVE_OUTLIER_MASK

          public static final int REMOVE_OUTLIER_MASK

      The inverse outliers mask.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Data

          public Data(int[][] data,
              java.lang.String[] header,
              int[] map,
              Dictionary dictionary)

      Creates a new data object.
      Parameters:
        `data` - The int array
        `header` - The header
        `map` - The map
        `dictionary` - The dictionary

  - ### Method Detail

    - #### clone

          public Data clone()

      Overrides:
        `clone` in class `java.lang.Object`

    - #### getArray

          public int[][] getArray()

      Returns the data array.
      Returns:

    - #### getData

          public int[][] getData()

      Returns the data.
      Returns:

    - #### getDataLength

          public int getDataLength()

      Returns the number of rows.
      Returns:
        the data length

    - #### getDictionary

          public Dictionary getDictionary()

      Returns the dictionary.
      Returns:

    - #### getHeader

          public java.lang.String[] getHeader()

      Returns the header.
      Returns:

    - #### getMap

          public int[] getMap()

      Returns the map.
      Returns:

    - #### getSubsetInstance

          public Data getSubsetInstance(RowSet rowset)

      Returns a new instance that is projected onto the given subset
      Parameters:
        `rowset` -
      Returns: